package cam.netapp;
//
//##################################################################
//  		       Class CircularList
//##################################################################
//
//	            Implementation   : Chris Anderson 6/97
//
//                  Created from code given in 
//
//        "JAVA Threads" by Scott Oaks and Harry Wong
//         O'Reilly and Associates, Sebastopol CA. 95472
//
//##################################################################
//
public class CircularList
{

public synchronized void insert(Object o)
{
    CircularListNode tn = new CircularListNode();
    tn.o                = o;
    if(current == null)
    {
        tn.prev = tn;
        tn.next = tn;
        current = tn;
    }
    else
    {
        tn.next           = current;
        tn.prev           = current.prev;
        current.prev.next = tn;
        current.prev      = tn;
    }
}
public synchronized void delete(Object o)
{
    CircularListNode p = find(o);
    CircularListNode next = p.next;
    CircularListNode prev = p.prev;
    if(p == p.next) // last object on the list
    {
    current = null;
    return;
    }
    prev.next = next;
    next.prev = prev;
    if(current == p) current = next;
}

private CircularListNode find(Object o)
{
    CircularListNode p = current;
    if(p == null)
    throw new IllegalArgumentException();
    do
    {
        if(p.o == o) return p;
        p = p.next;
    }while (p != current);
    throw new IllegalArgumentException();
}

public synchronized Object locate(Object o)
{
     CircularListNode p = current;
     do
     {
        if(p.o.equals(o)) return p.o;
        p = p.next;
     } while(p != current);
     throw new IllegalArgumentException();
}

public synchronized Object getNext()
{
    if(current == null)return null;
    current = current.next;
    return current.o;
}

private CircularListNode current;
}

