package cam.netapp;
import java.io.*;
//
//##################################################################
//  		       Interface SetStreams
//##################################################################
//
//	            Originator    : Chris Anderson 1997,1998
//              (C) UCLA
//
//##################################################################
//
//
//
/**
The SetStreams (interface) class defines the interface which &quot;remote&quot; classes must implement in order
that they can be instantiated by a request from a <A HREF="cam.netapp.NetworkConnection.html">NetworkConnection</A> object. 
The interface is defined by
<P>
<pre>
public interface SetStreams
{
   public boolean setInputStream(InputStream S);
   public boolean setOutputStream(OutputStream S);
}
</pre>
</P>

<P>The method <CODE>setInputStream(InputStream S)</CODE> should set an internal InputStream to S, and return &quot;true&quot;
if successful.</P>

<P>The method <CODE>setOutputStream(OutputStream S)</CODE> should set an internal OutputStream to S, and return
&quot;true&quot; if successful.</P>

@author Chris Anderson (C) UCLA 1997
@version 9/19/98
*/
public interface SetStreams
{
	public boolean setInputStream(InputStream S);
	public boolean setOutputStream(OutputStream S);
}
